#include "ntddk.h"
#include "openports.h"
#include "devioctl.h"


ULONG TSSBase;
char GDT[6];

void GetTssBase()
        {
	__asm{
	sgdt GDT
	str ecx
	and ecx,0fffffffch
	mov ebx,dword ptr GDT+2
	mov eax,[ebx+ecx]
	mov edx,[ebx+ecx+4]
	shr eax,16
	mov ecx,edx
	and ecx,0ff000000h
	and edx,0ffh
	shl edx,16
	or edx,ecx
	or eax,edx
	mov TSSBase,eax	
        }
       }
void PortsMapReadWrite(char* MapIO,DWORD Operation)
{
switch(Operation)
	{
case 0: // read
	__asm{
	pushf
	cld
	mov esi,TSSBase
	add esi,88h
	mov ecx,800h
	mov edi,MapIO
	rep movsd
	popf
	}
	break;
case 1: // write 
		__asm{
	pushf
	cld
	mov esi,MapIO
	mov edi,TSSBase
	add edi,88h
	mov ecx,800h
	rep movsd
	popf
	}
	break;
default:
	break;
	}
}

NTSTATUS IoctlReadWriteMap(PIRP pIrp, PIO_STACK_LOCATION pIrpStack, ULONG IoControlCode)
{
NTSTATUS Status;
ULONG InBufferSize;
ULONG OutBufferSize;
char* pBuffer;

InBufferSize=pIrpStack->Parameters.DeviceIoControl.InputBufferLength;
OutBufferSize=pIrpStack->Parameters.DeviceIoControl.OutputBufferLength;
pBuffer=(char*)pIrp->AssociatedIrp.SystemBuffer;

Status=STATUS_BUFFER_OVERFLOW;

switch(IoControlCode)
	{
default:
case IOCTL_READ_PORTS_MAP:
        if(OutBufferSize>=0x2000){
	Status=STATUS_SUCCESS;
        PortsMapReadWrite(pBuffer,0);             
        pIrp->IoStatus.Information = 0x2000;
				}
	break;
case IOCTL_WRITE_PORTS_MAP:
        if(InBufferSize>=0x2000){
        Status=STATUS_SUCCESS;
        PortsMapReadWrite(pBuffer,1);
        pIrp->IoStatus.Information = 0x2000;
				}
	}
return Status;
}


NTSTATUS Dispatch(PDEVICE_OBJECT DeviceObject,PIRP pIrp)
{
    PIO_STACK_LOCATION pIrpStack;
    NTSTATUS Status;

    pIrp->IoStatus.Information = 0;

    pIrpStack = IoGetCurrentIrpStackLocation(pIrp);

    Status = STATUS_NOT_IMPLEMENTED;

    switch (pIrpStack->MajorFunction)
    {
        case IRP_MJ_CREATE:
        case IRP_MJ_CLOSE:
            Status = STATUS_SUCCESS;
            break;

        case IRP_MJ_DEVICE_CONTROL:
        switch (pIrpStack->Parameters.DeviceIoControl.IoControlCode)
            {
            case IOCTL_READ_PORTS_MAP:
            case IOCTL_WRITE_PORTS_MAP:
            Status = IoctlReadWriteMap(pIrp,pIrpStack,
                     pIrpStack->Parameters.DeviceIoControl.IoControlCode);
                break;
            default: ;
            }
            break;
        default: ;
    }

    pIrp->IoStatus.Status = Status;
    IoCompleteRequest(pIrp, IO_NO_INCREMENT );
    return Status;
}

VOID Unload(IN PDRIVER_OBJECT DriverObject)
{
UNICODE_STRING WinDeviceName;
PDEVICE_OBJECT pDevice;

RtlInitUnicodeString(&WinDeviceName, DOS_DEVICE_NAME);
IoDeleteSymbolicLink(&WinDeviceName);
pDevice=DriverObject->DeviceObject;
while(pDevice!=NULL){IoDeleteDevice(pDevice);pDevice=pDevice->NextDevice;}
return;
}

NTSTATUS CreateDevice(PWSTR Name,DEVICE_TYPE Type, 
         PDRIVER_OBJECT DriverObj, PDEVICE_OBJECT *ppDevObj );

NTSTATUS 
DriverEntry(IN PDRIVER_OBJECT  DriverObject, IN PUNICODE_STRING RegistryPath) 
{ 
    NTSTATUS Status;
    PDEVICE_OBJECT DeviceObject;
    DriverObject->DriverUnload = Unload; 
    DriverObject->MajorFunction[IRP_MJ_CREATE]         = Dispatch;
    DriverObject->MajorFunction[IRP_MJ_CLOSE]          = Dispatch;
    DriverObject->MajorFunction[IRP_MJ_DEVICE_CONTROL] = Dispatch;
    Status=CreateDevice(DEVICE_NAME,OPENPORTS_DEVICE_TYPE,
                                        DriverObject,&DeviceObject);
    if(!NT_SUCCESS(Status))return Status;
    GetTssBase();  	
    return STATUS_SUCCESS; 
} 

NTSTATUS CreateDevice(PWSTR Name,DEVICE_TYPE Type, 
         PDRIVER_OBJECT DriverObj, PDEVICE_OBJECT *ppDevObj )


{
    NTSTATUS Status;  
    UNICODE_STRING NtDeviceName;
    UNICODE_STRING WinDeviceName;

    RtlInitUnicodeString(&NtDeviceName, Name);

    Status = IoCreateDevice(DriverObj,0,
                    &NtDeviceName,Type,0,FALSE,ppDevObj);

    if (!NT_SUCCESS(Status))return Status;
    RtlInitUnicodeString(&WinDeviceName, DOS_DEVICE_NAME);
    Status = IoCreateSymbolicLink( &WinDeviceName, &NtDeviceName );
    if (!NT_SUCCESS(Status))IoDeleteDevice(*ppDevObj);
    return Status;
}

 
 
